# PagerDuty API Reference > Full content of every PagerDuty API operation, one block per operation, each headed by its canonical URL. The index is at https://docs.pagerduty.com/llms.txt; the articles are at https://docs.pagerduty.com/llms-full.txt. --- URL: https://docs.pagerduty.com/developer/api/reference/events-v1/send-event/create-v1-event # Send an event to PagerDuty `POST https://events.pagerduty.com/generic/2010-04-15/create_event.json` Your monitoring tools should send PagerDuty a trigger event to report a new problem, or update an ongoing problem, depending on the event type. ## Request body (`application/json`) — required | Field | Type | Required | Description | |---|---|---|---| | `service_key` | string | yes | The GUID of one of your "Generic API" services. This is the "Integration Key" listed on a Generic API's service detail page. | | `event_type` | string | yes | The type of event. Can be `trigger`, `acknowledge` or `resolve`. One of: `trigger`, `acknowledge`, `resolve`. | | `incident_key` | string | | Identifies the incident to `trigger`, `acknowledge`, or `resolve`. Required unless the `event_type` is `trigger`. | | `description` | string | | Text that will appear in the incident's log associated with this event. Required for `trigger` events. | | `details` | object | | An arbitrary JSON object containing any data you'd like included in the incident log. | | `client` | string | | The name of the monitoring client that is triggering this event. (This field is only used for `trigger` events.) | | `client_url` | string (url) | | The URL of the monitoring client that is triggering this event. (This field is only used for `trigger` events.) | | `contexts` | array of one of: object \| object | | Contexts to be included with the incident trigger such as links to graphs or images. (This field is only used for `trigger` events.) | | `contexts[].type` | string | yes | (option 1) The type of context being attached to the incident. One of: `link`. | | `contexts[].href` | string (url) | yes | (option 1) The link being attached to the incident. | | `contexts[].text` | string | | (option 1) Optional information pertaining to this context link. | | `contexts[].type` | string | yes | (option 2) The type of context being attached to the incident. One of: `image`. | | `contexts[].src` | string (url) | yes | (option 2) The source of the image being attached to the incident. This image must be served via HTTPS. | | `contexts[].href` | string (url) | | (option 2) Optional link for the image. | | `contexts[].alt` | string | | (option 2) Optional alternative text for the image. | Example: Example Request Body ```json { "service_key": "e93facc04764012d7bfb002500d5d1a6", "incident_key": "srv01/HTTP", "event_type": "trigger", "description": "FAILURE for production/HTTP on machine srv01.acme.com", "client": "Sample Monitoring Service", "client_url": "https://monitoring.service.com", "details": { "ping time": "1500ms", "load avg": 0.75 }, "contexts": [ { "type": "link", "href": "http://acme.pagerduty.com" }, { "type": "link", "href": "http://acme.pagerduty.com" }, { "text": "View the incident on PagerDuty", "type": "image", "src": "https://chart.googleapis.com/chart?chs=600x400&chd=t:6,2,9,5,2,5,7,4,8,2,1&cht=lc&chds=a&chxt=y&chm=D,0033FF,0,0,5,1" }, { "type": "image", "src": "https://chart.googleapis.com/chart?chs=600x400&chd=t:6,2,9,5,2,5,7,4,8,2,1&cht=lc&chds=a&chxt=y&chm=D,0033FF,0,0,5,1", "href": "https://google.com" } ] } ``` ## Response 200 The incident has been opened or updated. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `status` | string | yes | A short name for the error, or "success" if successful. | | `incident_key` | string | | The key of the incident that will be affected by the request, if successful. | | `message` | string | | A description of the problem, or "Event processed" if successful. | Example: Example Success Response ```json { "status": "success", "message": "Event processed", "incident_key": "srv01/HTTP" } ``` ## Response 400 Invalid event format (i.e. JSON parse error) or incorrect event structure ## Response 403 Rate limit reached (too many Events API requests) ## Response 5XX An error occurred on a request. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `status` | string | yes | A short name for the error. | | `message` | string | yes | A description of the problem. | | `errors` | array of string | | An array of specific error messages. | Example: Example Error Response ```json { "status": "unrecognized object", "message": "Event object format is unrecognized", "errors": [ "JSON parse error" ] } ``` ## Developer Agreement Your access to and use of the PagerDuty Developer Services is governed by the [PagerDuty Developer Agreement](https://docs.pagerduty.com/developer/pagerduty-developer-agreement). --- URL: https://docs.pagerduty.com/developer/api/reference/events-v2/send-change-event/create-change-event # Send change events to the PagerDuty Events API `POST https://events.pagerduty.com/v2/change/enqueue` Change Events API enables you to send informational events about recent changes such as code deploys and system config changes from any system that can make an outbound HTTP connection. These events do not create incidents and do not send notifications; they are shown in context with incidents on the same PagerDuty service. ## Request body (`application/json`) — required | Field | Type | Required | Description | |---|---|---|---| | `payload` | object | yes | Fields adding additional context about the location, impact, and character of the PagerDuty event. | | `payload.summary` | string | yes | A brief text summary of the event, used to generate the summaries/titles of any associated alerts. | | `payload.timestamp` | string (date-time) | | The time at which the emitting tool detected or generated the event. | | `payload.source` | string | | The unique location of the affected system, preferably a hostname or FQDN. | | `payload.custom_details` | object | | Additional details about the event and affected system. | | `routing_key` | string | yes | The GUID of one of your Events API V2 integrations. This is the "Integration Key" listed on the Events API V2 integration's detail page. | | `links` | array of object | | Links to be shown on the alert and/or corresponding incident. | | `links[].href` | string (url) | yes | The link being attached to an incident or alert. | | `links[].text` | string | | Optional information pertaining to this context link. | | `images` | array of object | | Images to be displayed on the alert and/or corresponding incident. | | `images[].src` | string (url) | yes | The source of the image being attached to the incident or alert. This image must be served via HTTPS. | | `images[].href` | string (url) | | Optional link for the image. | | `images[].alt` | string | | Optional alternative text for the image. | Example: Build example Change Event Body ```json { "routing_key": "737ea619db564d41bd9824063e1f6b08", "payload": { "summary": "Build Success: Increase snapshot create timeout to 30 seconds", "timestamp": "2015-07-17T08:42:58.315+0000", "source": "prod-build-agent-i-0b148d1040d565540", "custom_details": { "build_state": "passed", "build_number": "220", "run_time": "1236s" } }, "links": [ { "href": "https://buildpipeline.com/pagerduty/deployment/builds/220", "text": "View in Build Pipeline" } ], "images": [ { "src": "https://chart.googleapis.com/chart?chs=600x400&chd=t:6,2,9,5,2,5,7,4,8,2,1&cht=lc&chds=a&chxt=y&chm=D,0033FF,0,0,5,1", "href": "https://google.com", "alt": "An example link with an image" } ] } ``` Example: Commited example Change Event Body ```json { "routing_key": "737ea619db564d41bd9824063e1f8au1", "payload": { "summary": "Merge Pull Request", "timestamp": "2015-07-17T08:42:58.315+0000", "source": "git", "custom_details": { "author": "Pagerduty" } }, "links": [ { "href": "https://buildpipeline.com/pagerduty/deployment/builds/220", "text": "View in Build Pipeline" } ] } ``` ## Response 202 An alert has been created or updated. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `status` | string | yes | Returns "success" if successful, or a short error message in case of a failure. | | `dedup_key` | string | | The key used to correlate triggers, acknowledges, and resolves for the same alert. | | `message` | string | | A description of the problem, or "Event processed" if successful. | Example: Example Success Response ```json { "status": "success", "message": "Event processed", "dedup_key": "srv01/HTTP" } ``` ## Response 400 #/components/responses/ArgumentError ## Response 429 #/components/responses/TooManyRequests ## Response 5XX An error occurred on a request. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `status` | string | yes | A short name for the error. | | `message` | string | yes | A description of the problem. | | `errors` | array of string | | An array of specific error messages. | Example: Example Error Response ```json { "status": "Unrecognized object", "message": "Event object format is unrecognized", "errors": [ "JSON parse error" ] } ``` ## Developer Agreement Your access to and use of the PagerDuty Developer Services is governed by the [PagerDuty Developer Agreement](https://docs.pagerduty.com/developer/pagerduty-developer-agreement). --- URL: https://docs.pagerduty.com/developer/api/reference/events-v2/send-event/create-v2-event # Send an event to PagerDuty `POST https://events.pagerduty.com/v2/enqueue` Your monitoring tools should send PagerDuty a trigger event to report a new problem, or update an ongoing problem, depending on the event type. ## Request body (`application/json`) — required | Field | Type | Required | Description | |---|---|---|---| | `payload` | object | | Fields adding additional context about the location, impact, and character of the PagerDuty event. | | `payload.summary` | string | yes | A brief text summary of the event, used to generate the summaries/titles of any associated alerts. | | `payload.timestamp` | string (date-time) | | The time at which the emitting tool detected or generated the event. | | `payload.severity` | | yes | The perceived severity of the status the event is describing withrespect to the affected system. One of: `critical`, `warning`, `error`, `info`. | | `payload.source` | string | yes | The unique location of the affected system, preferably a hostname or FQDN. | | `payload.component` | string | | Component of the source machine that is responsible for the event. | | `payload.group` | string | | Logical grouping of components of a service. | | `payload.class` | string | | The class/type of the event. | | `payload.custom_details` | object | | Additional details about the event and affected system. | | `routing_key` | string | yes | The GUID of one of your Events API V2 integrations. This is the "Integration Key" listed on the Events API V2 integration's detail page. | | `event_action` | | yes | The type of event. Can be `trigger`, `acknowledge` or `resolve`. One of: `trigger`, `acknowledge`, `resolve`. | | `dedup_key` | string | | Identifies the alert to `trigger`, `acknowledge`, or `resolve`. Required unless the `event_type` is `trigger`. | | `client` | string | | The name of the monitoring client that is triggering this event. (This field is only used for `trigger` events.) | | `client_url` | string (url) | | The URL of the monitoring client that is triggering this event. (This field is only used for `trigger` events.) | | `links` | array of object | | Links to be shown on the alert and/or corresponding incident. | | `links[].href` | string (url) | yes | The link being attached to an incident or alert. | | `links[].text` | string | | Optional information pertaining to this context link. | | `images` | array of object | | Images to be displayed on the alert and/or corresponding incident. | | `images[].src` | string (url) | yes | The source of the image being attached to the incident or alert. This image must be served via HTTPS. | | `images[].href` | string (url) | | Optional link for the image. | | `images[].alt` | string | | Optional alternative text for the image. | Example: Example Event Body ```json { "payload": { "summary": "DISK at 99% on machine prod-datapipe03.example.com", "timestamp": "2015-07-17T08:42:58.315+0000", "severity": "critical", "source": "prod-datapipe03.example.com", "component": "mysql", "group": "prod-datapipe", "class": "disk", "custom_details": { "free space": "1%", "ping time": "1500ms", "load avg": 0.75 } }, "routing_key": "e93facc04764012d7bfb002500d5d1a6", "dedup_key": "srv01/mysql", "event_action": "trigger", "client": "Sample Monitoring Service", "client_url": "https://monitoring.service.com", "links": [ { "href": "http://pagerduty.example.com", "text": "An example link." } ], "images": [ { "src": "https://chart.googleapis.com/chart?chs=600x400&chd=t:6,2,9,5,2,5,7,4,8,2,1&cht=lc&chds=a&chxt=y&chm=D,0033FF,0,0,5,1", "href": "https://google.com", "alt": "An example link with an image" } ] } ``` ## Response 202 An alert has been created or updated. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `status` | string | yes | Returns "success" if successful, or a short error message in case of a failure. | | `dedup_key` | string | | The key used to correlate triggers, acknowledges, and resolves for the same alert. | | `message` | string | | A description of the problem, or "Event processed" if successful. | Example: Example Success Response ```json { "status": "success", "message": "Event processed", "dedup_key": "srv01/HTTP" } ``` ## Response 400 #/components/responses/ArgumentError ## Response 429 #/components/responses/TooManyRequests ## Response 5XX An error occurred on a request. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `status` | string | yes | A short name for the error. | | `message` | string | yes | A description of the problem. | | `errors` | array of string | | An array of specific error messages. | Example: Example Error Response ```json { "status": "Unrecognized object", "message": "Event object format is unrecognized", "errors": [ "JSON parse error" ] } ``` ## Developer Agreement Your access to and use of the PagerDuty Developer Services is governed by the [PagerDuty Developer Agreement](https://docs.pagerduty.com/developer/pagerduty-developer-agreement). --- URL: https://docs.pagerduty.com/developer/api/reference/integration-jira-cloud/account-mappings/get-account-mapping # Get an account mapping `GET https://api.pagerduty.com/integration-jira-cloud/accounts_mappings/{id}` Get detailed information about a specific account mapping. An Account Mapping establishes a connection between a PagerDuty account and a Jira Cloud instance, enabling integration and synchronization between the two platforms. Scoped OAuth requires: `jira_cloud_accounts.read` ## Authorization - **apiKey** (apiKey) — `Authorization` header. - **bearerAuth** (http) — HTTP bearer. ## Path parameters | Name | Type | Required | Description | |---|---|---|---| | `id` | string (PagerDuty Id) | yes | The ID of the account mapping. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | ## Response 200 The account mapping requested. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `created_at` | string | yes | The time when the account mapping was created. | | `id` | string (PagerDuty Id) | yes | Unique identifier. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | | `jira_cloud_account` | object | yes | Details of the Jira Cloud instance connected to the PagerDuty account. | | `jira_cloud_account.base_url` | string | yes | The base URL of the Jira Cloud instance, used for API calls and constructing links. | | `pagerduty_account` | object | yes | Details of the PagerDuty account to which the integration is connected. | | `pagerduty_account.subdomain` | string | yes | The unique subdomain of the PagerDuty account, used to identify and access the account (e.g., `acme` in `https://acme.pagerduty.com`). | | `updated_at` | string \| null | | The time when the account mapping was last modified. | Example: Response Example ```json { "created_at": "2024-09-12T12:34:55.000Z", "id": "PIJ90N7", "jira_cloud_account": { "base_url": "https://atlassian-subdomain.atlassian.net" }, "pagerduty_account": { "subdomain": "pagerduty-subdomain" }, "updated_at": "2024-09-13T10:11:12.000Z" } ``` ## Response 400 Caller provided invalid arguments. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "code": 2001, "errors": [ "Invalid value for field 'name'" ], "message": "Invalid Input Provided" } } ``` ## Response 401 Caller did not supply credentials or did not provide the correct credentials. ## Response 403 Caller is not authorized to manage the requested resource. While the authentication is valid, the authenticated user or token does not have permission to perform this action. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "errors": [], "message": "Forbidden" } } ``` ## Response 429 Too many requests have been made, the rate limit has been reached. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "code": 2020, "message": "Rate Limit Exceeded" } } ``` ## Response 500 Internal server error. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "errors": [], "message": "Internal server error" } } ``` ## Developer Agreement Your access to and use of the PagerDuty Developer Services is governed by the [PagerDuty Developer Agreement](https://docs.pagerduty.com/developer/pagerduty-developer-agreement). --- URL: https://docs.pagerduty.com/developer/api/reference/integration-jira-cloud/account-mappings/get-account-mappings # List account mappings `GET https://api.pagerduty.com/integration-jira-cloud/accounts_mappings` List existing account mappings. An Account Mapping establishes a connection between a PagerDuty account and a Jira Cloud instance, enabling integration and synchronization between the two platforms. Scoped OAuth requires: `jira_cloud_accounts.read` ## Authorization - **apiKey** (apiKey) — `Authorization` header. - **bearerAuth** (http) — HTTP bearer. ## Query parameters | Name | Type | Required | Description | |---|---|---|---| | `offset` | integer | | Offset to start pagination search results. Default: `0`. Minimum: 0. [See our Pagination Docs for more information](https://developer.pagerduty.com/docs/ZG9jOjExMDI5NTU4-pagination). | | `limit` | integer | | The number of results per page. Default: `25`. Minimum: 1. Maximum: 100. [See our Pagination Docs for more information](https://developer.pagerduty.com/docs/ZG9jOjExMDI5NTU4-pagination). | | `total` | boolean | | By default the `total` field in pagination responses is set to `null` to provide the fastest possible response times. Set `total` to `true` for this field to be populated. See our [Pagination Docs](https://docs.pagerduty.com/developer/pagination) for more information. Default: `false`. [See our Pagination Docs for more information](https://developer.pagerduty.com/docs/ZG9jOjExMDI5NTU4-pagination). | ## Response 200 A paginated list of account mappings. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `accounts_mappings` | array of object | | | | `accounts_mappings[].created_at` | string | yes | The time when the account mapping was created. | | `accounts_mappings[].id` | string (PagerDuty Id) | yes | Unique identifier. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | | `accounts_mappings[].jira_cloud_account` | object | yes | Details of the Jira Cloud instance connected to the PagerDuty account. | | `accounts_mappings[].jira_cloud_account.base_url` | string | yes | The base URL of the Jira Cloud instance, used for API calls and constructing links. | | `accounts_mappings[].pagerduty_account` | object | yes | Details of the PagerDuty account to which the integration is connected. | | `accounts_mappings[].pagerduty_account.subdomain` | string | yes | The unique subdomain of the PagerDuty account, used to identify and access the account (e.g., `acme` in `https://acme.pagerduty.com`). | | `accounts_mappings[].updated_at` | string \| null | | The time when the account mapping was last modified. | | `limit` | integer | | Echoes limit pagination property. [See our Pagination Docs for more information](https://developer.pagerduty.com/docs/ZG9jOjExMDI5NTU4-pagination). | | `more` | boolean | | Indicates if there are additional records to return. [See our Pagination Docs for more information](https://developer.pagerduty.com/docs/ZG9jOjExMDI5NTU4-pagination). | | `offset` | integer | | Echoes limit pagination property. [See our Pagination Docs for more information](https://developer.pagerduty.com/docs/ZG9jOjExMDI5NTU4-pagination). | | `total` | integer \| null | | The total number of records matching the given query. [See our Pagination Docs for more information](https://developer.pagerduty.com/docs/ZG9jOjExMDI5NTU4-pagination). | Example: Request Example ```json { "accounts_mappings": [ { "created_at": "2024-09-12T12:34:55.000Z", "id": "PIJ90N7", "jira_cloud_account": { "base_url": "https://atlassian-subdomain.atlassian.net" }, "pagerduty_account": { "subdomain": "pagerduty-subdomain" }, "updated_at": "2024-09-13T10:11:12.000Z" } ], "limit": 25, "more": false, "offset": 0, "total": 1 } ``` ## Response 400 Caller provided invalid arguments. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "code": 2001, "errors": [ "Invalid value for field 'name'" ], "message": "Invalid Input Provided" } } ``` ## Response 401 Caller did not supply credentials or did not provide the correct credentials. ## Response 403 Caller is not authorized to manage the requested resource. While the authentication is valid, the authenticated user or token does not have permission to perform this action. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "errors": [], "message": "Forbidden" } } ``` ## Response 429 Too many requests have been made, the rate limit has been reached. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "code": 2020, "message": "Rate Limit Exceeded" } } ``` ## Response 500 Internal server error. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "errors": [], "message": "Internal server error" } } ``` ## Developer Agreement Your access to and use of the PagerDuty Developer Services is governed by the [PagerDuty Developer Agreement](https://docs.pagerduty.com/developer/pagerduty-developer-agreement). --- URL: https://docs.pagerduty.com/developer/api/reference/integration-jira-cloud/rules/create-rule # Create a rule `POST https://api.pagerduty.com/integration-jira-cloud/accounts_mappings/{id}/rules` Create a new rule. A Rule configures the bidirectional synchronization between Jira issues and PagerDuty incidents. Scoped OAuth requires: `jira_cloud_rules.write` ## Authorization - **apiKey** (apiKey) — `Authorization` header. - **bearerAuth** (http) — HTTP bearer. ## Path parameters | Name | Type | Required | Description | |---|---|---|---| | `id` | string (PagerDuty Id) | yes | The ID of the account mapping. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | ## Request body (`application/json`) — required The rule to be created. | Field | Type | Required | Description | |---|---|---|---| | `config` | object | yes | Configuration for bidirectional synchronization between Jira issues and PagerDuty incidents. | | `config.jira` | object | yes | Synchronization settings. | | `config.jira.autocreate_jql` | string \| null | yes | JQL query to automatically create PagerDuty incidents when matching Jira issues are created. Leave empty to disable this feature. | | `config.jira.create_issue_on_incident_trigger` | boolean | yes | When enabled, automatically creates a Jira issue whenever a PagerDuty incident is triggered. Default: `false`. | | `config.jira.custom_fields` | array \| null | yes | Defines how Jira fields are populated when a Jira Issue is created from a PagerDuty Incident. | | `config.jira.issue_type` | object | yes | Specifies the Jira issue type to be created or synchronized with PagerDuty incidents. | | `config.jira.issue_type.id` | string | yes | Unique identifier for the Jira issue type. | | `config.jira.issue_type.name` | string | yes | | | `config.jira.priorities` | array \| null | yes | Maps PagerDuty incident priorities to Jira issue priorities for synchronization. | | `config.jira.project` | object | yes | Defines the Jira project where issues will be created or synchronized. | | `config.jira.project.id` | string | yes | | | `config.jira.project.key` | string | yes | | | `config.jira.project.name` | string | yes | | | `config.jira.status_mapping` | object | yes | Maps PagerDuty incident statuses to corresponding Jira issue statuses for synchronization. | | `config.jira.status_mapping.acknowledged` | object \| null | | Optional Jira status that maps to the PagerDuty `acknowledged` status. | | `config.jira.status_mapping.acknowledged.id` | string | yes | Unique identifier for the Jira status. | | `config.jira.status_mapping.acknowledged.name` | string | yes | | | `config.jira.status_mapping.resolved` | object \| null | | Optional Jira status that maps to the PagerDuty `resolved` status. | | `config.jira.status_mapping.resolved.id` | string | yes | Unique identifier for the Jira status. | | `config.jira.status_mapping.resolved.name` | string | yes | | | `config.jira.status_mapping.triggered` | object | yes | Jira status that maps to the PagerDuty `triggered` status. | | `config.jira.status_mapping.triggered.id` | string | yes | Unique identifier for the Jira status. | | `config.jira.status_mapping.triggered.name` | string | yes | | | `config.jira.sync_notes_user` | object \| null | yes | PagerDuty user for syncing notes and comments between Jira issues and PagerDuty incidents. If not provided, note synchronization is disabled. | | `config.jira.sync_notes_user.id` | string (PagerDuty Id) | yes | Unique identifier. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | | `config.jira.sync_notes_user.type` | string | yes | One of: `user_reference`. | | `config.service` | object | yes | The PagerDuty service associated with this rule. | | `config.service.id` | string (PagerDuty Id) | yes | Unique identifier. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | | `config.service.type` | string | yes | One of: `service_reference`. | | `enabled` | boolean \| null | | Whether the rule is enabled. | | `name` | string | yes | The name of the rule. Max length: 100. Pattern: `^[^\x00-\x1F\x7F<>]+$`. | Example: Request Example ```json { "config": { "jira": { "autocreate_jql": "priority = Highest", "create_issue_on_incident_trigger": true, "custom_fields": [ { "source_incident_field": "incident_description", "target_issue_field": "description", "target_issue_field_name": "Description", "type": "attribute" }, { "source_incident_field": "incident_number", "target_issue_field": "customfield_10001", "target_issue_field_name": "PagerDuty Incident Number", "type": "attribute" }, { "target_issue_field": "security", "target_issue_field_name": "Security Level", "type": "jira_value", "value": { "displayName": "Sec Level 1", "id": "10000" } }, { "target_issue_field": "labels", "target_issue_field_name": "Labels", "type": "const", "value": "pagerduty, incident" } ], "issue_type": { "id": "10001", "name": "Incident" }, "priorities": [ { "jira_id": "1", "pagerduty_id": "PUS0KTE" }, { "jira_id": "2", "pagerduty_id": "PQFCJER" }, { "jira_id": "3", "pagerduty_id": "PN6RJ21" } ], "project": { "id": "10100", "key": "ITS", "name": "IT Support" }, "status_mapping": { "acknowledged": { "id": "2", "name": "In Progress" }, "resolved": { "id": "3", "name": "Resolved" }, "triggered": { "id": "1", "name": "Open" } }, "sync_notes_user": { "id": "PBAZLIU", "type": "user_reference" } }, "service": { "id": "PY1OL64", "type": "service_reference" } }, "name": "Critical IT Incidents", "enabled": true } ``` ## Response 201 The rule that was created. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `account_mapping` | object | yes | Account mapping to which the rule belongs. | | `account_mapping.id` | string (PagerDuty Id) | yes | Unique identifier. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | | `account_mapping.self` | string | yes | The API URL at which the object is accessible. | | `account_mapping.type` | string | yes | One of: `account_mapping_reference`. | | `autocreate_jql_disabled_reason` | string \| null | | If auto-creation using JQL is disabled, this field provides the reason for the disablement. | | `autocreate_jql_disabled_until` | string \| null | | The timestamp until which the auto-creation using JQL feature is disabled. | | `config` | object | yes | Configuration for bidirectional synchronization between Jira issues and PagerDuty incidents. | | `config.jira` | object | yes | Synchronization settings. | | `config.jira.autocreate_jql` | string \| null | | JQL query to automatically create PagerDuty incidents when matching Jira issues are created. Leave empty to disable this feature. | | `config.jira.create_issue_on_incident_trigger` | boolean | yes | When enabled, automatically creates a Jira issue whenever a PagerDuty incident is triggered. Default: `false`. | | `config.jira.custom_fields` | array \| null | | Defines how Jira fields are populated when a Jira Issue is created from a PagerDuty Incident. | | `config.jira.issue_type` | object | yes | Jira issue type to be created or synchronized with PagerDuty incidents. | | `config.jira.issue_type.id` | string | yes | Unique identifier for the Jira issue type. | | `config.jira.issue_type.name` | string | yes | | | `config.jira.priorities` | array \| null | | Maps PagerDuty incident priorities to Jira issue priorities for synchronization. | | `config.jira.project` | object | yes | Jira project where issues will be created or synchronized. | | `config.jira.project.id` | string | yes | Unique identifier for the Jira project. | | `config.jira.project.key` | string | yes | Unique identifier key for the Jira project. | | `config.jira.project.name` | string | yes | | | `config.jira.status_mapping` | object | yes | Maps PagerDuty incident statuses to corresponding Jira issue statuses for synchronization. | | `config.jira.status_mapping.acknowledged` | object \| null | | Optional Jira status that maps to the PagerDuty `acknowledged` status. | | `config.jira.status_mapping.acknowledged.id` | string \| null | | Unique identifier for the Jira status. | | `config.jira.status_mapping.acknowledged.name` | string \| null | | | | `config.jira.status_mapping.resolved` | object \| null | | Optional Jira status that maps to the PagerDuty `resolved` status. | | `config.jira.status_mapping.resolved.id` | string \| null | | Unique identifier for the Jira status. | | `config.jira.status_mapping.resolved.name` | string \| null | | | | `config.jira.status_mapping.triggered` | object | yes | Jira status that maps to the PagerDuty `triggered` status. | | `config.jira.status_mapping.triggered.id` | string | yes | Unique identifier for the Jira status. | | `config.jira.status_mapping.triggered.name` | string | yes | | | `config.jira.sync_notes_user` | object \| null | | PagerDuty user for syncing notes and comments between Jira issues and PagerDuty incidents. If not provided, note synchronization is disabled. | | `config.jira.sync_notes_user.email` | string | yes | | | `config.jira.sync_notes_user.html_url` | string \| null | | The URL at which the user is uniquely displayed in the PagerDuty web app. | | `config.jira.sync_notes_user.id` | string (PagerDuty Id) | yes | Unique identifier. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | | `config.jira.sync_notes_user.name` | string | yes | | | `config.jira.sync_notes_user.self` | string | | The API URL at which the object is accessible. | | `config.jira.sync_notes_user.type` | string | yes | One of: `user_reference`. | | `config.service` | object | yes | The PagerDuty service associated with this rule. | | `config.service.html_url` | string \| null | | The URL at which the service is uniquely displayed in the PagerDuty web app. | | `config.service.id` | string (PagerDuty Id) | yes | Unique identifier. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | | `config.service.self` | string | | The API URL at which the object is accessible. | | `config.service.summary` | string | yes | The name or summary of the PagerDuty service. | | `config.service.type` | string | yes | One of: `service_reference`. | | `created_at` | string | yes | The time when the rule was created. | | `enabled` | boolean | | Indicates if the rule is enabled. | | `id` | string (PagerDuty Id) | yes | Unique identifier. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | | `name` | string | yes | The name of the rule. Max length: 100. Pattern: `^[^\x00-\x1F\x7F<>]+$`. | | `updated_at` | string \| null | | The time when the rule was last modified. | Example: Response Example ```json { "account_mapping": { "id": "PIJ90N7", "self": "https://api.pagerduty.com/integration-jira-cloud/account_mappings/PIJ90N7", "type": "accounts_mapping_reference" }, "config": { "jira": { "autocreate_jql": "priority = Highest", "create_issue_on_incident_trigger": true, "custom_fields": [ { "source_incident_field": "incident_description", "target_issue_field": "description", "target_issue_field_name": "Description", "type": "attribute" }, { "source_incident_field": "incident_number", "target_issue_field": "customfield_10001", "target_issue_field_name": "PagerDuty Incident Number", "type": "attribute" }, { "target_issue_field": "security", "target_issue_field_name": "Security Level", "type": "jira_value", "value": { "displayName": "Sec Level 1", "id": "10000" } }, { "target_issue_field": "labels", "target_issue_field_name": "Labels", "type": "const", "value": "pagerduty, incident" } ], "issue_type": { "id": "10001", "name": "Incident" }, "priorities": [ { "jira_id": "1", "pagerduty_id": "PUS0KTE" }, { "jira_id": "2", "pagerduty_id": "PQFCJER" }, { "jira_id": "3", "pagerduty_id": "PN6RJ21" } ], "project": { "id": "10100", "key": "ITS", "name": "IT Support" }, "status_mapping": { "acknowledged": { "id": "2", "name": "In Progress" }, "resolved": { "id": "3", "name": "Resolved" }, "triggered": { "id": "1", "name": "Open" } }, "sync_notes_user": { "email": "e.greenholt@example.com", "html_url": "https://subdomain.pagerduty.com/users/PBAZLIU", "id": "PBAZLIU", "name": "Earline Greenholt", "self": "https://api.pagerduty.com/users/PBAZLIU", "type": "user_reference" }, "version": 1 }, "service": { "html_url": "https://api.pagerduty.com/services/PY1OL64", "id": "PY1OL64", "self": "https://api.pagerduty.com/services/PY1OL64", "summary": "Main Web Application", "type": "service_reference" } }, "created_at": "2023-09-01T12:00:00.000Z", "id": "PF9KMXH", "name": "Critical IT Incidents", "enabled": true, "updated_at": "2023-09-01T12:00:00.000Z" } ``` ## Response 400 Caller provided invalid arguments. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "code": 2001, "errors": [ "Invalid value for field 'name'" ], "message": "Invalid Input Provided" } } ``` ## Response 401 Caller did not supply credentials or did not provide the correct credentials. ## Response 403 Caller is not authorized to manage the requested resource. While the authentication is valid, the authenticated user or token does not have permission to perform this action. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "errors": [], "message": "Forbidden" } } ``` ## Response 429 Too many requests have been made, the rate limit has been reached. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "code": 2020, "message": "Rate Limit Exceeded" } } ``` ## Response 500 Internal server error. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "errors": [], "message": "Internal server error" } } ``` ## Developer Agreement Your access to and use of the PagerDuty Developer Services is governed by the [PagerDuty Developer Agreement](https://docs.pagerduty.com/developer/pagerduty-developer-agreement). --- URL: https://docs.pagerduty.com/developer/api/reference/integration-jira-cloud/rules/delete-rule # Delete a rule `DELETE https://api.pagerduty.com/integration-jira-cloud/accounts_mappings/{id}/rules/{rule_id}` Delete an existing rule. Once a rule is deleted, the synchronization between PagerDuty Incidents and Jira Issues linked by the rule stops. Scoped OAuth requires: `jira_cloud_rules.write` ## Authorization - **apiKey** (apiKey) — `Authorization` header. - **bearerAuth** (http) — HTTP bearer. ## Path parameters | Name | Type | Required | Description | |---|---|---|---| | `id` | string (PagerDuty Id) | yes | The ID of the account mapping. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | | `rule_id` | string (PagerDuty Id) | yes | The ID of the account rule. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | ## Response 204 The rule was deleted successfully. ## Response 400 Caller provided invalid arguments. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "code": 2001, "errors": [ "Invalid value for field 'name'" ], "message": "Invalid Input Provided" } } ``` ## Response 401 Caller did not supply credentials or did not provide the correct credentials. ## Response 403 Caller is not authorized to manage the requested resource. While the authentication is valid, the authenticated user or token does not have permission to perform this action. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "errors": [], "message": "Forbidden" } } ``` ## Response 429 Too many requests have been made, the rate limit has been reached. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "code": 2020, "message": "Rate Limit Exceeded" } } ``` ## Response 500 Internal server error. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "errors": [], "message": "Internal server error" } } ``` ## Developer Agreement Your access to and use of the PagerDuty Developer Services is governed by the [PagerDuty Developer Agreement](https://docs.pagerduty.com/developer/pagerduty-developer-agreement). --- URL: https://docs.pagerduty.com/developer/api/reference/integration-jira-cloud/rules/get-rule # Get a rule `GET https://api.pagerduty.com/integration-jira-cloud/accounts_mappings/{id}/rules/{rule_id}` Get detailed information about an existing rule. A Rule configures the bidirectional synchronization between Jira issues and PagerDuty incidents. Scoped OAuth requires: `jira_cloud_rules.read` ## Authorization - **apiKey** (apiKey) — `Authorization` header. - **bearerAuth** (http) — HTTP bearer. ## Path parameters | Name | Type | Required | Description | |---|---|---|---| | `id` | string (PagerDuty Id) | yes | The ID of the account mapping. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | | `rule_id` | string (PagerDuty Id) | yes | The ID of the account rule. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | ## Response 200 The rule requested. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `account_mapping` | object | yes | Account mapping to which the rule belongs. | | `account_mapping.id` | string (PagerDuty Id) | yes | Unique identifier. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | | `account_mapping.self` | string | yes | The API URL at which the object is accessible. | | `account_mapping.type` | string | yes | One of: `account_mapping_reference`. | | `autocreate_jql_disabled_reason` | string \| null | | If auto-creation using JQL is disabled, this field provides the reason for the disablement. | | `autocreate_jql_disabled_until` | string \| null | | The timestamp until which the auto-creation using JQL feature is disabled. | | `config` | object | yes | Configuration for bidirectional synchronization between Jira issues and PagerDuty incidents. | | `config.jira` | object | yes | Synchronization settings. | | `config.jira.autocreate_jql` | string \| null | | JQL query to automatically create PagerDuty incidents when matching Jira issues are created. Leave empty to disable this feature. | | `config.jira.create_issue_on_incident_trigger` | boolean | yes | When enabled, automatically creates a Jira issue whenever a PagerDuty incident is triggered. Default: `false`. | | `config.jira.custom_fields` | array \| null | | Defines how Jira fields are populated when a Jira Issue is created from a PagerDuty Incident. | | `config.jira.issue_type` | object | yes | Jira issue type to be created or synchronized with PagerDuty incidents. | | `config.jira.issue_type.id` | string | yes | Unique identifier for the Jira issue type. | | `config.jira.issue_type.name` | string | yes | | | `config.jira.priorities` | array \| null | | Maps PagerDuty incident priorities to Jira issue priorities for synchronization. | | `config.jira.project` | object | yes | Jira project where issues will be created or synchronized. | | `config.jira.project.id` | string | yes | Unique identifier for the Jira project. | | `config.jira.project.key` | string | yes | Unique identifier key for the Jira project. | | `config.jira.project.name` | string | yes | | | `config.jira.status_mapping` | object | yes | Maps PagerDuty incident statuses to corresponding Jira issue statuses for synchronization. | | `config.jira.status_mapping.acknowledged` | object \| null | | Optional Jira status that maps to the PagerDuty `acknowledged` status. | | `config.jira.status_mapping.acknowledged.id` | string \| null | | Unique identifier for the Jira status. | | `config.jira.status_mapping.acknowledged.name` | string \| null | | | | `config.jira.status_mapping.resolved` | object \| null | | Optional Jira status that maps to the PagerDuty `resolved` status. | | `config.jira.status_mapping.resolved.id` | string \| null | | Unique identifier for the Jira status. | | `config.jira.status_mapping.resolved.name` | string \| null | | | | `config.jira.status_mapping.triggered` | object | yes | Jira status that maps to the PagerDuty `triggered` status. | | `config.jira.status_mapping.triggered.id` | string | yes | Unique identifier for the Jira status. | | `config.jira.status_mapping.triggered.name` | string | yes | | | `config.jira.sync_notes_user` | object \| null | | PagerDuty user for syncing notes and comments between Jira issues and PagerDuty incidents. If not provided, note synchronization is disabled. | | `config.jira.sync_notes_user.email` | string | yes | | | `config.jira.sync_notes_user.html_url` | string \| null | | The URL at which the user is uniquely displayed in the PagerDuty web app. | | `config.jira.sync_notes_user.id` | string (PagerDuty Id) | yes | Unique identifier. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | | `config.jira.sync_notes_user.name` | string | yes | | | `config.jira.sync_notes_user.self` | string | | The API URL at which the object is accessible. | | `config.jira.sync_notes_user.type` | string | yes | One of: `user_reference`. | | `config.service` | object | yes | The PagerDuty service associated with this rule. | | `config.service.html_url` | string \| null | | The URL at which the service is uniquely displayed in the PagerDuty web app. | | `config.service.id` | string (PagerDuty Id) | yes | Unique identifier. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | | `config.service.self` | string | | The API URL at which the object is accessible. | | `config.service.summary` | string | yes | The name or summary of the PagerDuty service. | | `config.service.type` | string | yes | One of: `service_reference`. | | `created_at` | string | yes | The time when the rule was created. | | `enabled` | boolean | | Indicates if the rule is enabled. | | `id` | string (PagerDuty Id) | yes | Unique identifier. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | | `name` | string | yes | The name of the rule. Max length: 100. Pattern: `^[^\x00-\x1F\x7F<>]+$`. | | `updated_at` | string \| null | | The time when the rule was last modified. | Example: Response Example ```json { "account_mapping": { "id": "PIJ90N7", "self": "https://api.pagerduty.com/integration-jira-cloud/account_mappings/PIJ90N7", "type": "accounts_mapping_reference" }, "config": { "jira": { "autocreate_jql": "priority = High", "create_issue_on_incident_trigger": true, "custom_fields": [ { "source_incident_field": "incident_description", "target_issue_field": "description", "target_issue_field_name": "Description", "type": "attribute" } ], "issue_type": { "id": "10001", "name": "Incident" }, "priorities": [ { "jira_id": "1", "pagerduty_id": "PUS0KTE" }, { "jira_id": "2", "pagerduty_id": "PQFCJER" } ], "project": { "id": "10100", "key": "ITS", "name": "IT Support" }, "status_mapping": { "acknowledged": { "id": "2", "name": "In Progress" }, "resolved": { "id": "3", "name": "Resolved" }, "triggered": { "id": "1", "name": "Open" } }, "sync_notes_user": { "email": "e.greenholt@example.com", "html_url": "https://subdomain.pagerduty.com/users/PBAZLIU", "id": "PBAZLIU", "name": "Earline Greenholt", "self": "https://api.pagerduty.com/users/PBAZLIU", "type": "user_reference" } }, "service": { "html_url": "https://api.pagerduty.com/services/PY1OL64", "id": "PY1OL64", "self": "https://api.pagerduty.com/services/PY1OL64", "summary": "Main Web Application", "type": "service_reference" }, "version": 1 }, "created_at": "2023-09-01T12:00:00.000Z", "id": "PF9KMXH", "name": "Critical IT Incidents", "enabled": true, "updated_at": "2023-09-01T12:00:00.000Z" } ``` ## Response 400 Caller provided invalid arguments. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "code": 2001, "errors": [ "Invalid value for field 'name'" ], "message": "Invalid Input Provided" } } ``` ## Response 401 Caller did not supply credentials or did not provide the correct credentials. ## Response 403 Caller is not authorized to manage the requested resource. While the authentication is valid, the authenticated user or token does not have permission to perform this action. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "errors": [], "message": "Forbidden" } } ``` ## Response 429 Too many requests have been made, the rate limit has been reached. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "code": 2020, "message": "Rate Limit Exceeded" } } ``` ## Response 500 Internal server error. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "errors": [], "message": "Internal server error" } } ``` ## Developer Agreement Your access to and use of the PagerDuty Developer Services is governed by the [PagerDuty Developer Agreement](https://docs.pagerduty.com/developer/pagerduty-developer-agreement). --- URL: https://docs.pagerduty.com/developer/api/reference/integration-jira-cloud/rules/get-rules # List rules `GET https://api.pagerduty.com/integration-jira-cloud/accounts_mappings/{id}/rules` List existing rules for a specific account mapping. A Rule configures the bidirectional synchronization between Jira issues and PagerDuty incidents. Scoped OAuth requires: `jira_cloud_rules.read` ## Authorization - **apiKey** (apiKey) — `Authorization` header. - **bearerAuth** (http) — HTTP bearer. ## Path parameters | Name | Type | Required | Description | |---|---|---|---| | `id` | string (PagerDuty Id) | yes | The ID of the account mapping. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | ## Query parameters | Name | Type | Required | Description | |---|---|---|---| | `offset` | integer | | Offset to start pagination search results. Default: `0`. Minimum: 0. [See our Pagination Docs for more information](https://developer.pagerduty.com/docs/ZG9jOjExMDI5NTU4-pagination). | | `limit` | integer | | The number of results per page. Default: `25`. Minimum: 1. Maximum: 100. [See our Pagination Docs for more information](https://developer.pagerduty.com/docs/ZG9jOjExMDI5NTU4-pagination). | | `total` | boolean | | By default the `total` field in pagination responses is set to `null` to provide the fastest possible response times. Set `total` to `true` for this field to be populated. See our [Pagination Docs](https://docs.pagerduty.com/developer/pagination) for more information. Default: `false`. [See our Pagination Docs for more information](https://developer.pagerduty.com/docs/ZG9jOjExMDI5NTU4-pagination). | ## Response 200 A paginated list of rules. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `limit` | integer | | Echoes limit pagination property. [See our Pagination Docs for more information](https://developer.pagerduty.com/docs/ZG9jOjExMDI5NTU4-pagination). | | `more` | boolean | | Indicates if there are additional records to return. [See our Pagination Docs for more information](https://developer.pagerduty.com/docs/ZG9jOjExMDI5NTU4-pagination). | | `offset` | integer | | Echoes limit pagination property. [See our Pagination Docs for more information](https://developer.pagerduty.com/docs/ZG9jOjExMDI5NTU4-pagination). | | `rules` | array of object | | | | `rules[].account_mapping` | object | yes | Account mapping to which the rule belongs. | | `rules[].account_mapping.id` | string (PagerDuty Id) | yes | Unique identifier. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | | `rules[].account_mapping.self` | string | yes | The API URL at which the object is accessible. | | `rules[].account_mapping.type` | string | yes | One of: `account_mapping_reference`. | | `rules[].autocreate_jql_disabled_reason` | string \| null | | If auto-creation using JQL is disabled, this field provides the reason for the disablement. | | `rules[].autocreate_jql_disabled_until` | string \| null | | The timestamp until which the auto-creation using JQL feature is disabled. | | `rules[].config` | object | yes | Configuration for bidirectional synchronization between Jira issues and PagerDuty incidents. | | `rules[].config.jira` | object | yes | Synchronization settings. | | `rules[].config.jira.autocreate_jql` | string \| null | | JQL query to automatically create PagerDuty incidents when matching Jira issues are created. Leave empty to disable this feature. | | `rules[].config.jira.create_issue_on_incident_trigger` | boolean | yes | When enabled, automatically creates a Jira issue whenever a PagerDuty incident is triggered. Default: `false`. | | `rules[].config.jira.custom_fields` | array \| null | | Defines how Jira fields are populated when a Jira Issue is created from a PagerDuty Incident. | | `rules[].config.jira.issue_type` | object | yes | Jira issue type to be created or synchronized with PagerDuty incidents. | | `rules[].config.jira.issue_type.id` | string | yes | Unique identifier for the Jira issue type. | | `rules[].config.jira.issue_type.name` | string | yes | | | `rules[].config.jira.priorities` | array \| null | | Maps PagerDuty incident priorities to Jira issue priorities for synchronization. | | `rules[].config.jira.project` | object | yes | Jira project where issues will be created or synchronized. | | `rules[].config.jira.project.id` | string | yes | Unique identifier for the Jira project. | | `rules[].config.jira.project.key` | string | yes | Unique identifier key for the Jira project. | | `rules[].config.jira.project.name` | string | yes | | | `rules[].config.jira.status_mapping` | object | yes | Maps PagerDuty incident statuses to corresponding Jira issue statuses for synchronization. | | `rules[].config.jira.status_mapping.acknowledged` | object \| null | | Optional Jira status that maps to the PagerDuty `acknowledged` status. | | `rules[].config.jira.status_mapping.acknowledged.id` | string \| null | | Unique identifier for the Jira status. | | `rules[].config.jira.status_mapping.acknowledged.name` | string \| null | | | | `rules[].config.jira.status_mapping.resolved` | object \| null | | Optional Jira status that maps to the PagerDuty `resolved` status. | | `rules[].config.jira.status_mapping.resolved.id` | string \| null | | Unique identifier for the Jira status. | | `rules[].config.jira.status_mapping.resolved.name` | string \| null | | | | `rules[].config.jira.status_mapping.triggered` | object | yes | Jira status that maps to the PagerDuty `triggered` status. | | `rules[].config.jira.status_mapping.triggered.id` | string | yes | Unique identifier for the Jira status. | | `rules[].config.jira.status_mapping.triggered.name` | string | yes | | | `rules[].config.jira.sync_notes_user` | object \| null | | PagerDuty user for syncing notes and comments between Jira issues and PagerDuty incidents. If not provided, note synchronization is disabled. | | `rules[].config.jira.sync_notes_user.email` | string | yes | | | `rules[].config.jira.sync_notes_user.html_url` | string \| null | | The URL at which the user is uniquely displayed in the PagerDuty web app. | | `rules[].config.jira.sync_notes_user.id` | string (PagerDuty Id) | yes | Unique identifier. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | | `rules[].config.jira.sync_notes_user.name` | string | yes | | | `rules[].config.jira.sync_notes_user.self` | string | | The API URL at which the object is accessible. | | `rules[].config.jira.sync_notes_user.type` | string | yes | One of: `user_reference`. | | `rules[].config.service` | object | yes | The PagerDuty service associated with this rule. | | `rules[].config.service.html_url` | string \| null | | The URL at which the service is uniquely displayed in the PagerDuty web app. | | `rules[].config.service.id` | string (PagerDuty Id) | yes | Unique identifier. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | | `rules[].config.service.self` | string | | The API URL at which the object is accessible. | | `rules[].config.service.summary` | string | yes | The name or summary of the PagerDuty service. | | `rules[].config.service.type` | string | yes | One of: `service_reference`. | | `rules[].created_at` | string | yes | The time when the rule was created. | | `rules[].enabled` | boolean | | Indicates if the rule is enabled. | | `rules[].id` | string (PagerDuty Id) | yes | Unique identifier. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | | `rules[].name` | string | yes | The name of the rule. Max length: 100. Pattern: `^[^\x00-\x1F\x7F<>]+$`. | | `rules[].updated_at` | string \| null | | The time when the rule was last modified. | | `total` | integer \| null | | The total number of records matching the given query. [See our Pagination Docs for more information](https://developer.pagerduty.com/docs/ZG9jOjExMDI5NTU4-pagination). | Example: Response Example ```json { "limit": 25, "more": false, "offset": 0, "rules": [ { "account_mapping": { "id": "PIJ90N7", "self": "https://api.pagerduty.com/integration-jira-cloud/account_mappings/PIJ90N7", "type": "accounts_mapping_reference" }, "config": { "jira": { "autocreate_jql": "priority = High", "create_issue_on_incident_trigger": true, "custom_fields": [ { "source_incident_field": "incident_description", "target_issue_field": "description", "target_issue_field_name": "Description", "type": "attribute" } ], "issue_type": { "id": "10001", "name": "Incident" }, "priorities": [ { "jira_id": "1", "pagerduty_id": "PUS0KTE" }, { "jira_id": "2", "pagerduty_id": "PQFCJER" } ], "project": { "id": "10100", "key": "ITS", "name": "IT Support" }, "status_mapping": { "acknowledged": { "id": "2", "name": "In Progress" }, "resolved": { "id": "3", "name": "Resolved" }, "triggered": { "id": "1", "name": "Open" } }, "sync_notes_user": { "email": "e.greenholt@example.com", "html_url": "https://subdomain.pagerduty.com/users/PBAZLIU", "id": "PBAZLIU", "name": "Earline Greenholt", "self": "https://api.pagerduty.com/users/PBAZLIU", "type": "user_reference" } }, "service": { "html_url": "https://api.pagerduty.com/services/PY1OL64", "id": "PY1OL64", "self": "https://api.pagerduty.com/services/PY1OL64", "summary": "Main Web Application", "type": "service_reference" }, "version": 1 }, "created_at": "2023-09-01T12:00:00.000Z", "id": "PF9KMXH", "name": "Critical Incidents to Jira", "updated_at": "2023-09-01T12:00:00.000Z" } ], "total": 1 } ``` ## Response 400 Caller provided invalid arguments. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "code": 2001, "errors": [ "Invalid value for field 'name'" ], "message": "Invalid Input Provided" } } ``` ## Response 401 Caller did not supply credentials or did not provide the correct credentials. ## Response 403 Caller is not authorized to manage the requested resource. While the authentication is valid, the authenticated user or token does not have permission to perform this action. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "errors": [], "message": "Forbidden" } } ``` ## Response 429 Too many requests have been made, the rate limit has been reached. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "code": 2020, "message": "Rate Limit Exceeded" } } ``` ## Response 500 Internal server error. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "errors": [], "message": "Internal server error" } } ``` ## Developer Agreement Your access to and use of the PagerDuty Developer Services is governed by the [PagerDuty Developer Agreement](https://docs.pagerduty.com/developer/pagerduty-developer-agreement). --- URL: https://docs.pagerduty.com/developer/api/reference/integration-jira-cloud/rules/update-rule # Update a rule `PUT https://api.pagerduty.com/integration-jira-cloud/accounts_mappings/{id}/rules/{rule_id}` Update an existing rule. A Rule configures the bidirectional synchronization between Jira issues and PagerDuty incidents. Scoped OAuth requires: `jira_cloud_rules.write` ## Authorization - **apiKey** (apiKey) — `Authorization` header. - **bearerAuth** (http) — HTTP bearer. ## Path parameters | Name | Type | Required | Description | |---|---|---|---| | `id` | string (PagerDuty Id) | yes | The ID of the account mapping. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | | `rule_id` | string (PagerDuty Id) | yes | The ID of the account rule. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | ## Request body (`application/json`) — required The rule to be updated. | Field | Type | Required | Description | |---|---|---|---| | `config` | object | yes | Configuration for bidirectional synchronization between Jira issues and PagerDuty incidents. | | `config.jira` | object | yes | Synchronization settings. | | `config.jira.autocreate_jql` | string \| null | yes | JQL query to automatically create PagerDuty incidents when matching Jira issues are created. Leave empty to disable this feature. | | `config.jira.create_issue_on_incident_trigger` | boolean | yes | When enabled, automatically creates a Jira issue whenever a PagerDuty incident is triggered. Default: `false`. | | `config.jira.custom_fields` | array \| null | yes | Defines how Jira fields are populated when a Jira Issue is created from a PagerDuty Incident. | | `config.jira.issue_type` | object | yes | Specifies the Jira issue type to be created or synchronized with PagerDuty incidents. | | `config.jira.issue_type.id` | string | yes | Unique identifier for the Jira issue type. | | `config.jira.issue_type.name` | string | yes | | | `config.jira.priorities` | array \| null | yes | Maps PagerDuty incident priorities to Jira issue priorities for synchronization. | | `config.jira.status_mapping` | object | yes | Maps PagerDuty incident statuses to corresponding Jira issue statuses for synchronization. | | `config.jira.status_mapping.acknowledged` | object \| null | | Optional Jira status that maps to the PagerDuty `acknowledged` status. | | `config.jira.status_mapping.acknowledged.id` | string | yes | Unique identifier for the Jira status. | | `config.jira.status_mapping.acknowledged.name` | string | yes | | | `config.jira.status_mapping.resolved` | object \| null | | Optional Jira status that maps to the PagerDuty `resolved` status. | | `config.jira.status_mapping.resolved.id` | string | yes | Unique identifier for the Jira status. | | `config.jira.status_mapping.resolved.name` | string | yes | | | `config.jira.status_mapping.triggered` | object | yes | Jira status that maps to the PagerDuty `triggered` status. | | `config.jira.status_mapping.triggered.id` | string | yes | Unique identifier for the Jira status. | | `config.jira.status_mapping.triggered.name` | string | yes | | | `config.jira.sync_notes_user` | object \| null | yes | PagerDuty user for syncing notes and comments between Jira issues and PagerDuty incidents. If not provided, note synchronization is disabled. | | `config.jira.sync_notes_user.id` | string (PagerDuty Id) | yes | Unique identifier. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | | `config.jira.sync_notes_user.type` | string | yes | One of: `user_reference`. | | `enabled` | boolean \| null | | Indicates if the rule is enabled. | | `name` | string | yes | The name of the rule. Max length: 100. Pattern: `^[^\x00-\x1F\x7F<>]+$`. | Example: Request Example ```json { "config": { "jira": { "autocreate_jql": "priority in (Highest, High)", "create_issue_on_incident_trigger": false, "custom_fields": [ { "source_incident_field": "incident_description", "target_issue_field": "description", "target_issue_field_name": "Description", "type": "attribute" }, { "source_incident_field": "incident_number", "target_issue_field": "customfield_10001", "target_issue_field_name": "PagerDuty Incident Number", "type": "attribute" }, { "target_issue_field": "security", "target_issue_field_name": "Security Level", "type": "jira_value", "value": { "displayName": "Sec Level 1", "id": "10000" } } ], "issue_type": { "id": "10001", "name": "Incident" }, "priorities": [ { "jira_id": "1", "pagerduty_id": "PUS0KTE" }, { "jira_id": "2", "pagerduty_id": "PQFCJER" }, { "jira_id": "3", "pagerduty_id": "PN6RJ21" } ], "status_mapping": { "acknowledged": { "id": "2", "name": "In Progress" }, "resolved": { "id": "3", "name": "Resolved" }, "triggered": { "id": "1", "name": "Open" } }, "sync_notes_user": { "id": "PBAZLIU", "type": "user_reference" } } }, "name": "Critical IT Incidents", "enabled": true } ``` ## Response 200 The rule that was updated. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `account_mapping` | object | yes | Account mapping to which the rule belongs. | | `account_mapping.id` | string (PagerDuty Id) | yes | Unique identifier. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | | `account_mapping.self` | string | yes | The API URL at which the object is accessible. | | `account_mapping.type` | string | yes | One of: `account_mapping_reference`. | | `autocreate_jql_disabled_reason` | string \| null | | If auto-creation using JQL is disabled, this field provides the reason for the disablement. | | `autocreate_jql_disabled_until` | string \| null | | The timestamp until which the auto-creation using JQL feature is disabled. | | `config` | object | yes | Configuration for bidirectional synchronization between Jira issues and PagerDuty incidents. | | `config.jira` | object | yes | Synchronization settings. | | `config.jira.autocreate_jql` | string \| null | | JQL query to automatically create PagerDuty incidents when matching Jira issues are created. Leave empty to disable this feature. | | `config.jira.create_issue_on_incident_trigger` | boolean | yes | When enabled, automatically creates a Jira issue whenever a PagerDuty incident is triggered. Default: `false`. | | `config.jira.custom_fields` | array \| null | | Defines how Jira fields are populated when a Jira Issue is created from a PagerDuty Incident. | | `config.jira.issue_type` | object | yes | Jira issue type to be created or synchronized with PagerDuty incidents. | | `config.jira.issue_type.id` | string | yes | Unique identifier for the Jira issue type. | | `config.jira.issue_type.name` | string | yes | | | `config.jira.priorities` | array \| null | | Maps PagerDuty incident priorities to Jira issue priorities for synchronization. | | `config.jira.project` | object | yes | Jira project where issues will be created or synchronized. | | `config.jira.project.id` | string | yes | Unique identifier for the Jira project. | | `config.jira.project.key` | string | yes | Unique identifier key for the Jira project. | | `config.jira.project.name` | string | yes | | | `config.jira.status_mapping` | object | yes | Maps PagerDuty incident statuses to corresponding Jira issue statuses for synchronization. | | `config.jira.status_mapping.acknowledged` | object \| null | | Optional Jira status that maps to the PagerDuty `acknowledged` status. | | `config.jira.status_mapping.acknowledged.id` | string \| null | | Unique identifier for the Jira status. | | `config.jira.status_mapping.acknowledged.name` | string \| null | | | | `config.jira.status_mapping.resolved` | object \| null | | Optional Jira status that maps to the PagerDuty `resolved` status. | | `config.jira.status_mapping.resolved.id` | string \| null | | Unique identifier for the Jira status. | | `config.jira.status_mapping.resolved.name` | string \| null | | | | `config.jira.status_mapping.triggered` | object | yes | Jira status that maps to the PagerDuty `triggered` status. | | `config.jira.status_mapping.triggered.id` | string | yes | Unique identifier for the Jira status. | | `config.jira.status_mapping.triggered.name` | string | yes | | | `config.jira.sync_notes_user` | object \| null | | PagerDuty user for syncing notes and comments between Jira issues and PagerDuty incidents. If not provided, note synchronization is disabled. | | `config.jira.sync_notes_user.email` | string | yes | | | `config.jira.sync_notes_user.html_url` | string \| null | | The URL at which the user is uniquely displayed in the PagerDuty web app. | | `config.jira.sync_notes_user.id` | string (PagerDuty Id) | yes | Unique identifier. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | | `config.jira.sync_notes_user.name` | string | yes | | | `config.jira.sync_notes_user.self` | string | | The API URL at which the object is accessible. | | `config.jira.sync_notes_user.type` | string | yes | One of: `user_reference`. | | `config.service` | object | yes | The PagerDuty service associated with this rule. | | `config.service.html_url` | string \| null | | The URL at which the service is uniquely displayed in the PagerDuty web app. | | `config.service.id` | string (PagerDuty Id) | yes | Unique identifier. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | | `config.service.self` | string | | The API URL at which the object is accessible. | | `config.service.summary` | string | yes | The name or summary of the PagerDuty service. | | `config.service.type` | string | yes | One of: `service_reference`. | | `created_at` | string | yes | The time when the rule was created. | | `enabled` | boolean | | Indicates if the rule is enabled. | | `id` | string (PagerDuty Id) | yes | Unique identifier. Pattern: `^(P[0-9A-Z]{6}\|Q[0-9A-Z]{13})$`. | | `name` | string | yes | The name of the rule. Max length: 100. Pattern: `^[^\x00-\x1F\x7F<>]+$`. | | `updated_at` | string \| null | | The time when the rule was last modified. | Example: Response Example ```json { "account_mapping": { "id": "PIJ90N7", "self": "https://api.pagerduty.com/integration-jira-cloud/account_mappings/PIJ90N7", "type": "accounts_mapping_reference" }, "config": { "jira": { "autocreate_jql": "priority in (Highest, High)", "create_issue_on_incident_trigger": false, "custom_fields": [ { "source_incident_field": "incident_description", "target_issue_field": "description", "target_issue_field_name": "Description", "type": "attribute" }, { "source_incident_field": "incident_number", "target_issue_field": "customfield_10001", "target_issue_field_name": "PagerDuty Incident Number", "type": "attribute" }, { "target_issue_field": "security", "target_issue_field_name": "Security Level", "type": "jira_value", "value": { "displayName": "Sec Level 1", "id": "10000" } } ], "issue_type": { "id": "10001", "name": "Incident" }, "priorities": [ { "jira_id": "1", "pagerduty_id": "PUS0KTE" }, { "jira_id": "2", "pagerduty_id": "PQFCJER" }, { "jira_id": "3", "pagerduty_id": "PN6RJ21" } ], "project": { "id": "10100", "key": "ITS", "name": "IT Support" }, "status_mapping": { "acknowledged": { "id": "2", "name": "In Progress" }, "resolved": { "id": "3", "name": "Resolved" }, "triggered": { "id": "1", "name": "Open" } }, "sync_notes_user": { "email": "e.greenholt@example.com", "html_url": "https://subdomain.pagerduty.com/users/PBAZLIU", "id": "PBAZLIU", "name": "Earline Greenholt", "self": "https://api.pagerduty.com/users/PBAZLIU", "type": "user_reference" }, "version": 1 }, "service": { "html_url": "https://api.pagerduty.com/services/PY1OL64", "id": "PY1OL64", "self": "https://api.pagerduty.com/services/PY1OL64", "summary": "Main Web Application", "type": "service_reference" } }, "created_at": "2023-09-01T12:00:00.000Z", "id": "PF9KMXH", "name": "Critical IT Incidents", "enabled": true, "updated_at": "2023-09-01T12:00:00.000Z" } ``` ## Response 400 Caller provided invalid arguments. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "code": 2001, "errors": [ "Invalid value for field 'name'" ], "message": "Invalid Input Provided" } } ``` ## Response 401 Caller did not supply credentials or did not provide the correct credentials. ## Response 403 Caller is not authorized to manage the requested resource. While the authentication is valid, the authenticated user or token does not have permission to perform this action. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "errors": [], "message": "Forbidden" } } ``` ## Response 429 Too many requests have been made, the rate limit has been reached. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "code": 2020, "message": "Rate Limit Exceeded" } } ``` ## Response 500 Internal server error. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `error` | object | | | | `error.code` | integer | | Error code. | | `error.errors` | array of string | | Error details. | | `error.message` | string | | Error message. | Example: Response Example ```json { "error": { "errors": [], "message": "Internal server error" } } ``` ## Developer Agreement Your access to and use of the PagerDuty Developer Services is governed by the [PagerDuty Developer Agreement](https://docs.pagerduty.com/developer/pagerduty-developer-agreement). --- URL: https://docs.pagerduty.com/developer/api/reference/integration-jira-service/rules/create-rule # Create a rule `POST https://app.pagerduty.com/integration-jira-service/rules` Creates a rule. The maximum number of rules a user could have is 2000. If the limit is reached, API will respond with an error. > ### Action required! > > Make sure that all required PagerDuty and Jira webhooks are present. You can do this by clicking **Check webhooks** button on the *Rules* page of the PagerDuty Jira application ## Authorization - **BearerToken** (http) — HTTP bearer. PagerDuty OAuth user Access Token The developer should obtain a valid user-based bearer token by performing Classic User OAuth by following our public documentation: https://developer.pagerduty.com/docs/b2a19cce2867a-classic-user-o-auth ## Header parameters | Name | Type | Required | Description | |---|---|---|---| | `x-pagerduty-jira-signature` | string | yes | Connected Jira instance signature token This header contains a signature token that validates the connection between PagerDuty and a specific Jira instance. It must be included in all API requests. > ### Obtaining the signature token > > 1. Send an authenticated GET request to your Jira instance: `GET /plugins/servlet/pagerduty/sign` > > 2. The endpoint returns a JSON response containing the signature: `{ "signature": "eyJ0eXAiOiJK..." }` > > 3. Use the returned signature value in the x-pagerduty-jira-signature header for all subsequent API calls. Note: Signature token is valid for 15 minutes after generation. | ## Request body (`application/json`) | Field | Type | Required | Description | |---|---|---|---| | `rule` | object | yes | | | `rule.name` | string | yes | A name of the rule. Max length: 128. | | `rule.enabled` | boolean | yes | Indicates if the rule is enabled. Default: `false`. | | `rule.config` | object | yes | Contatins an object which describes a rule. | | `rule.config.sync_comments` | boolean | | Indicates if comments should be synchronized. Default: `false`. | | `rule.config.services` | array of object | | An array of the PagerDuty services. Min items: 1. | | `rule.config.services[].id` | string | yes | | | `rule.config.services[].summary` | string | | A short-form, server-generated string that provides succinct, important information about an object suitable for primary labeling of an entity in a client. In many cases, this will be identical to `name`, though it is not intended to be an identifier. | | `rule.config.services[].type` | string | yes | One of: `service_reference`. | | `rule.config.services[].self` | string (url) | | The API show URL at which the object is accessible. | | `rule.config.services[].html_url` | string \| null (url) | | A URL at which the entity is uniquely displayed in the Web app. | | `rule.config.projects` | array of object \| null | | An array of Jira projects. Min items: 1. | | `rule.config.projects[].id` | string | yes | | | `rule.config.projects[].key` | string | yes | | | `rule.config.projects[].label` | string | yes | | | `rule.config.projects[].icon` | string (url) | yes | | | `rule.config.projects[].html_url` | string (url) | yes | | | `rule.config.issue_types` | array of object \| null | | An array of Jira issue types. Min items: 1. | | `rule.config.issue_types[].id` | string | yes | | | `rule.config.issue_types[].label` | string | yes | | | `rule.config.issue_types[].icon` | string (url) | yes | | | `rule.config.autocreate_issues` | boolean | | Indicates if automatic Jira issue creation is enabled. Default: `false`. | | `rule.config.autocreate_issues_config` | array of object | | An array of rules that are applied when automatic Jira issue creation is enabled. | | `rule.config.autocreate_issues_config[].condition` | object | | | | `rule.config.autocreate_issues_config[].condition.pd_events` | array of string | | A list of PagerDuty incident actions which should be matched to create a Jira issue. | | `rule.config.autocreate_issues_config[].condition.pd_priorities` | array of object | | A list of PagerDuty priorities that should be matched to create/update a Jira issue. | | `rule.config.autocreate_issues_config[].condition.pd_priorities[].id` | string | yes | | | `rule.config.autocreate_issues_config[].condition.pd_priorities[].summary` | string | | A short-form, server-generated string that provides succinct, important information about an object suitable for primary labeling of an entity in a client. In many cases, this will be identical to `name`, though it is not intended to be an identifier. | | `rule.config.autocreate_issues_config[].condition.pd_priorities[].type` | string | yes | One of: `priority_reference`. | | `rule.config.autocreate_issues_config[].condition.pd_priorities[].self` | string (url) | | The API show URL at which the object is accessible. | | `rule.config.autocreate_issues_config[].condition.pd_priorities[].html_url` | string \| null (url) | | A URL at which the entity is uniquely displayed in the Web app. | | `rule.config.autocreate_issues_config[].condition.pd_urgency` | string \| null | | A PagerDuty urgency that should be matched to create/update a Jira issue. One of: `high`, `low`. | | `rule.config.autocreate_issues_config[].actions` | array of object | | Actions that applied when the rule will be executed. | | `rule.config.autocreate_issues_config[].actions_params` | object | | Configuration of actions that applied when the rule will be executed. | | `rule.config.autocreate_issues_config[].target_project` | object \| null | | Jira Project. | | `rule.config.autocreate_issues_config[].target_project.id` | string | yes | | | `rule.config.autocreate_issues_config[].target_project.key` | string | yes | | | `rule.config.autocreate_issues_config[].target_project.label` | string | yes | | | `rule.config.autocreate_issues_config[].target_project.icon` | string (url) | yes | | | `rule.config.autocreate_issues_config[].target_project.html_url` | string (url) | yes | | | `rule.config.autocreate_issues_config[].target_issue_type` | object \| null | | Jira Issue Type. | | `rule.config.autocreate_issues_config[].target_issue_type.id` | string | yes | | | `rule.config.autocreate_issues_config[].target_issue_type.label` | string | yes | | | `rule.config.autocreate_issues_config[].target_issue_type.icon` | string (url) | yes | | | `rule.config.autocreate_incidents` | boolean | | Indicates if automatic PagerDuty incident creation is enabled. Default: `false`. | | `rule.config.autocreate_incidents_config` | array of object | | An array of rules that are applied when automatic PagerDuty incident creation is enabled. | | `rule.config.autocreate_incidents_config[].jql` | string | yes | Rule will be applied, when issue matches the JQL. | | `rule.config.autocreate_incidents_config[].on_create` | boolean | | Apply the rule on issue creation. Default: `false`. | | `rule.config.autocreate_incidents_config[].on_update` | boolean | | Apply the rule on issue update. Default: `false`. | | `rule.config.autocreate_incidents_config[].actions` | array of object | | Actions that applied when the rule will be executed. | | `rule.config.autocreate_incidents_config[].actions_params` | object | | Configuration of actions that applied when the rule will be executed. | | `rule.config.autocreate_incidents_config[].target_service` | object | | The reference to the service. | | `rule.config.autocreate_incidents_config[].target_service.id` | string | yes | | | `rule.config.autocreate_incidents_config[].target_service.summary` | string | | A short-form, server-generated string that provides succinct, important information about an object suitable for primary labeling of an entity in a client. In many cases, this will be identical to `name`, though it is not intended to be an identifier. | | `rule.config.autocreate_incidents_config[].target_service.type` | string | yes | One of: `service_reference`. | | `rule.config.autocreate_incidents_config[].target_service.self` | string (url) | | The API show URL at which the object is accessible. | | `rule.config.autocreate_incidents_config[].target_service.html_url` | string \| null (url) | | A URL at which the entity is uniquely displayed in the Web app. | | `rule.config.react_on_incident_event` | boolean | | Indicates if reaction on PagerDuty incident updates is enabled. Default: `false`. | | `rule.config.react_on_incident_event_config` | array of object | | An array of rules that are applied to the Jira issue when reaction on PagerDuty incident updates is enabled. | | `rule.config.react_on_incident_event_config[].condition` | object | | | | `rule.config.react_on_incident_event_config[].condition.pd_events` | array of string | | A list of PagerDuty incident actions which should be matched to update a Jira issue. | | `rule.config.react_on_incident_event_config[].condition.pd_priorities` | array of object | | A list of PagerDuty priorities that should be matched to create/update a Jira issue. Same fields as `rule.config.autocreate_issues_config[].condition.pd_priorities` above. | | `rule.config.react_on_incident_event_config[].condition.pd_urgency` | string \| null | | A PagerDuty urgency that should be matched to create/update a Jira issue. One of: `high`, `low`. | | `rule.config.react_on_incident_event_config[].actions` | array of object | | Actions that applied when the rule will be executed. | | `rule.config.react_on_incident_event_config[].actions_params` | object | | Configuration of actions that applied when the rule will be executed. | | `rule.config.react_on_incident_event_config[].target_project` | object \| null | | Jira Project. Same fields as `rule.config.autocreate_issues_config[].target_project` above. | | `rule.config.react_on_incident_event_config[].target_issue_type` | object | | Issue Type, which should set on the issue. | | `rule.config.react_on_incident_event_config[].target_issue_type.id` | string | yes | | | `rule.config.react_on_incident_event_config[].target_issue_type.label` | string | yes | | | `rule.config.react_on_incident_event_config[].target_issue_type.icon` | string (url) | yes | | | `rule.config.react_on_issue_status_change` | boolean | | Indicates if reaction on Jira issue status change is enabled. Default: `false`. | | `rule.config.react_on_issue_status_change_config` | array of object | | An array of rules that are applied to the PagerDuty incident when reaction on Jira issue status change is enabled. | | `rule.config.react_on_issue_status_change_config[].jira_statuses` | array of object | | | | `rule.config.react_on_issue_status_change_config[].jira_statuses[].id` | string | yes | | | `rule.config.react_on_issue_status_change_config[].jira_statuses[].label` | string | | | | `rule.config.react_on_issue_status_change_config[].actions` | array of object | | Actions that applied when the rule will be executed. | | `rule.config.react_on_issue_status_change_config[].actions_params` | object | | Configuration of actions that applied when the rule will be executed. | | `rule.created_at` | string (date-time) | yes | The date/time rule was created. Read-only. | Example: Request Example ```json { "rule": { "name": "Sample Rule", "created_at": "2020-06-02T12:42:37Z", "enabled": true, "config": { "sync_comments": true, "services": [ { "id": "PLW70S2", "type": "service_reference", "label": "Jira Integration", "html_url": "https://subdomain.pagerduty.com/service-directory/PLW70S2" }, { "id": "PR5R1T1", "type": "service_reference", "label": "Jira Performance Tests", "html_url": "https://subdomain.pagerduty.com/service-directory/PR5R1T1" } ], "projects": [ { "key": "PD", "id": "10000", "label": "PagerDuty", "html_url": "http://jira.example.com/projects/PD", "icon": "http://jira.example.com/secure/projectavatar?avatarId=10324" }, { "key": "HD", "id": "10001", "label": "Helpdesk", "html_url": "http://jira.example.com/projects/HD", "icon": "http://jira.example.com/secure/projectavatar?avatarId=10324" } ], "issue_types": [ { "id": "10002", "icon": "http://jira.example.com/images/icons/issuetypes/story.svg", "label": "Story" }, { "id": "10003", "icon": "http://jira.example.com/secure/viewavatar?size=xsmall&avatarId=10318&avatarType=issuetype", "label": "Task" }, { "id": "10004", "icon": "http://jira.example.com/secure/viewavatar?size=xsmall&avatarId=10303&avatarType=issuetype", "label": "Bug" } ], "autocreate_incidents": true, "autocreate_incidents_config": [ { "jql": "issuetype=Bug", "on_create": true, "on_update": true, "target_service": { "id": "PR5R1T1", "type": "service_reference" }, "actions": [ { "key": "jira_field_set_priority", "label": "Set Priority", "icon": "jira", "isDisabled": false }, { "key": "jira_field_set_labels", "label": "Set Labels", "icon": "jira", "isDisabled": false }, { "key": "pd_set_priority", "label": "Set Incident Priority", "icon": "pd", "isDisabled": false } ], "actions_params": { "jira_field_set_priority": { "label": "Highest", "icon": "http://jira.example.com/images/icons/priorities/highest.svg", "name": "Highest", "id": "1" }, "jira_field_set_labels": [ { "label": "Service name", "icon": "pd", "key": "incident.service.summary" } ], "pd_set_priority": { "id": "PZQ39X0", "type": "priority_reference", "label": "P1", "html_url": null, "icon": "rect_color_ff4500" } } }, { "jql": "issuetype=Story", "on_create": true, "on_update": true, "target_service": { "id": "PR5R1T1", "type": "service_reference" }, "actions": [ { "key": "jira_field_set_labels", "label": "Set Labels", "icon": "jira", "isDisabled": false }, { "key": "pd_set_priority", "label": "Set Incident Priority", "icon": "pd", "isDisabled": false } ], "actions_params": { "jira_field_set_labels": [ { "label": "LinkedToPagerduty", "key": "LinkedToPagerduty", "icon": "text" } ], "pd_set_priority": { "id": "PCNJ47O", "type": "priority_reference", "label": "P4", "html_url": null, "icon": "rect_color_76ec7f" } } } ], "autocreate_issues": true, "autocreate_issues_config": [ { "condition": { "pd_events": [ "incident.trigger", "incident.acknowledge", "incident.unacknowledge", "incident.resolve", "incident.escalate", "incident.assign", "incident.delegate", "incident.trigger_manually" ], "pd_urgency": "high", "pd_priorities": [] }, "target_project": null, "target_issue_type": null, "actions": [ { "key": "jira_append_description", "label": "Add description", "icon": "jira", "isDisabled": false } ], "actions_params": { "jira_append_description": [ { "label": "Incident title", "icon": "pd", "key": "incident.title" }, { "label": "Incident number", "icon": "pd", "key": "incident.incident_number" }, { "label": "Incident ID", "icon": "pd", "key": "incident.id" }, { "label": "Description", "icon": "pd", "key": "log_entries.channel.details" }, { "label": "Status", "icon": "pd", "key": "incident.status" }, { "label": "Created At", "icon": "pd", "key": "incident.created_at" }, { "label": "Service name", "icon": "pd", "key": "incident.service.summary" }, { "label": "Escalation policy name", "icon": "pd", "key": "incident.escalation_policy.summary" }, { "label": "Impacted services", "icon": "pd", "key": "incident.impacted_services.name" }, { "label": "Incident URL", "icon": "pd", "key": "incident.html_url" }, { "label": "Acknowledgements", "icon": "pd", "key": "incident.acknowledgements.acknowledger.name" }, { "label": "Urgency", "icon": "pd", "key": "incident.urgency" }, { "label": "Incident assignee", "icon": "pd", "key": "incident.assignee" }, { "label": "Priority", "icon": "pd", "key": "incident.priority.summary" }, { "label": "Last changed by", "icon": "pd", "key": "incident.last_status_change_by.summary" }, { "label": "Last changed at", "icon": "pd", "key": "incident.last_status_change_at" }, { "label": "And my custom text", "key": "And my custom text", "icon": "text" } ] } }, { "condition": { "pd_events": [ "incident.trigger" ], "pd_urgency": "high", "pd_priorities": [ { "id": "PZQ39X0", "type": "priority_reference", "label": "P1", "html_url": null, "icon": "rect_color_ff4500" }, { "id": "POV67SK", "type": "priority_reference", "label": "P2", "html_url": null, "icon": "rect_color_f59331" } ] }, "target_project": { "key": "HD", "id": "10001", "label": "Helpdesk", "html_url": "http://jira.example.com/projects/HD", "icon": "http://jira.example.com/secure/projectavatar?avatarId=10324" }, "target_issue_type": { "id": "10004", "icon": "http://jira.example.com/secure/viewavatar?size=xsmall&avatarId=10303&avatarType=issuetype", "label": "Bug" }, "actions": [ { "key": "jira_field_set_priority", "label": "Set Priority", "icon": "jira", "isDisabled": false } ], "actions_params": { "jira_field_set_priority": { "label": "Highest", "icon": "http://jira.example.com/images/icons/priorities/highest.svg", "name": "Highest", "id": "1" } } }, { "condition": { "pd_events": [ "incident.trigger" ], "pd_urgency": "low", "pd_priorities": [ { "id": "P0A95OH", "type": "priority_reference", "label": "P3", "html_url": null, "icon": "rect_color_359d54" }, { "id": "PCNJ47O", "type": "priority_reference", "label": "P4", "html_url": null, "icon": "rect_color_76ec7f" }, { "id": "PRSM238", "type": "priority_reference", "label": "P5", "html_url": null, "icon": "rect_color_f4f4f4" } ] }, "target_project": null, "target_issue_type": { "id": "10004", "icon": "http://jira.example.com/secure/viewavatar?size=xsmall&avatarId=10303&avatarType=issuetype", "label": "Bug" }, "actions": [ { "key": "jira_field_set_priority", "label": "Set Priority", "icon": "jira", "isDisabled": false } ], "actions_params": { "jira_field_set_priority": { "label": "Low", "icon": "http://jira.example.com/images/icons/priorities/low.svg", "name": "Low", "id": "4" } } } ], "react_on_incident_event": true, "react_on_incident_event_config": [ { "condition": { "pd_events": [ "incident.acknowledge" ], "pd_urgency": "high", "pd_priorities": [] }, "actions": [ { "key": "jira_change_status", "label": "Change Jira issue status to", "icon": "jira", "isDisabled": false } ], "actions_params": { "jira_change_status": { "id": "3", "label": "In Progress" } } }, { "condition": { "pd_events": [ "incident.unacknowledge" ], "pd_urgency": "high", "pd_priorities": [] }, "actions": [ { "key": "jira_change_status", "label": "Change Jira issue status to", "icon": "jira", "isDisabled": false } ], "actions_params": { "jira_change_status": { "id": "10000", "label": "To Do" } } }, { "condition": { "pd_events": [ "incident.resolve" ], "pd_urgency": "high", "pd_priorities": [] }, "actions": [ { "key": "jira_change_status", "label": "Change Jira issue status to", "icon": "jira", "isDisabled": false } ], "actions_params": { "jira_change_status": { "id": "10001", "label": "Done" } } }, { "condition": { "pd_events": [ "incident.assign" ], "pd_urgency": "high", "pd_priorities": [] }, "actions": [ { "key": "jira_field_set_assignee", "label": "Set Assignee", "icon": "jira", "isDisabled": false } ], "actions_params": { "jira_field_set_assignee": { "label": "Incident assignee", "icon": "pd", "key": "incident.assignee" } } } ], "react_on_issue_status_change": true, "react_on_issue_status_change_config": [ { "jira_statuses": [ { "id": "3", "label": "In Progress" } ], "actions": [ { "key": "pd_acknowledge", "label": "Acknowledge Incident", "icon": "pd", "isDisabled": false } ] }, { "jira_statuses": [ { "id": "10001", "label": "Done" } ], "actions": [ { "key": "pd_resolve", "label": "Resolve Incident", "icon": "pd", "isDisabled": false } ] }, { "jira_statuses": [ { "id": "10000", "label": "To Do" } ], "actions": [ { "key": "pd_add_responders", "label": "Add responders", "icon": "pd", "isDisabled": false } ], "actions_params": { "pd_add_responders": [ { "id": "PDU13T4", "type": "user_reference", "email": "user1@example.com", "label": "User 1", "html_url": "https://subdomain.pagerduty.com/users/PDU13T4", "icon": "https://pd-static-assets.pagerduty.com/users/blank-avatar.png" }, { "id": "PKH7YP2", "type": "user_reference", "email": "user2@example.com", "label": "User 2", "html_url": "https://subdomain.pagerduty.com/users/PKH7YP2", "icon": "https://pd-static-assets.pagerduty.com/users/blank-avatar.png" } ] } } ] } } } ``` ## Response 200 The rule that was created. ### `application/json` | Field | Type | Required | Description | |---|---|---|---| | `rule` | object | yes | Same fields as `rule` above. | Example: Response Example ```json { "rule": { "name": "Sample Rule", "created_at": "2020-06-02T12:42:37Z", "enabled": true, "config": { "sync_comments": true, "services": [ { "id": "PLW70S2", "type": "service_reference", "label": "Jira Integration", "html_url": "https://subdomain.pagerduty.com/service-directory/PLW70S2" }, { "id": "PR5R1T1", "type": "service_reference", "label": "Jira Performance Tests", "html_url": "https://subdomain.pagerduty.com/service-directory/PR5R1T1" } ], "projects": [ { "key": "PD", "id": "10000", "label": "PagerDuty", "html_url": "http://jira.example.com/projects/PD", "icon": "http://jira.example.com/secure/projectavatar?avatarId=10324" }, { "key": "HD", "id": "10001", "label": "Helpdesk", "html_url": "http://jira.example.com/projects/HD", "icon": "http://jira.example.com/secure/projectavatar?avatarId=10324" } ], "issue_types": [ { "id": "10002", "icon": "http://jira.example.com/images/icons/issuetypes/story.svg", "label": "Story" }, { "id": "10003", "icon": "http://jira.example.com/secure/viewavatar?size=xsmall&avatarId=10318&avatarType=issuetype", "label": "Task" }, { "id": "10004", "icon": "http://jira.example.com/secure/viewavatar?size=xsmall&avatarId=10303&avatarType=issuetype", "label": "Bug" } ], "autocreate_incidents": true, "autocreate_incidents_config": [ { "jql": "issuetype=Bug", "on_create": true, "on_update": true, "target_service": { "id": "PR5R1T1", "type": "service_reference" }, "actions": [ { "key": "jira_field_set_priority", "label": "Set Priority", "icon": "jira", "isDisabled": false }, { "key": "jira_field_set_labels", "label": "Set Labels", "icon": "jira", "isDisabled": false }, { "key": "pd_set_priority", "label": "Set Incident Priority", "icon": "pd", "isDisabled": false } ], "actions_params": { "jira_field_set_priority": { "label": "Highest", "icon": "http://jira.example.com/images/icons/priorities/highest.svg", "name": "Highest", "id": "1" }, "jira_field_set_labels": [ { "label": "Service name", "icon": "pd", "key": "incident.service.summary" } ], "pd_set_priority": { "id": "PZQ39X0", "type": "priority_reference", "label": "P1", "html_url": null, "icon": "rect_color_ff4500" } } }, { "jql": "issuetype=Story", "on_create": true, "on_update": true, "target_service": { "id": "PR5R1T1", "type": "service_reference" }, "actions": [ { "key": "jira_field_set_labels", "label": "Set Labels", "icon": "jira", "isDisabled": false }, { "key": "pd_set_priority", "label": "Set Incident Priority", "icon": "pd", "isDisabled": false } ], "actions_params": { "jira_field_set_labels": [ { "label": "LinkedToPagerduty", "key": "LinkedToPagerduty", "icon": "text" } ], "pd_set_priority": { "id": "PCNJ47O", "type": "priority_reference", "label": "P4", "html_url": null, "icon": "rect_color_76ec7f" } } } ], "autocreate_issues": true, "autocreate_issues_config": [ { 
[...]
